<?php

namespace eBizCharge\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRecurringBilling ArrayType
 * @subpackage Arrays
 */
class ArrayOfRecurringBilling extends AbstractStructArrayBase
{
    /**
     * The RecurringBilling
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \eBizCharge\StructType\RecurringBilling[]
     */
    public $RecurringBilling;
    /**
     * Constructor method for ArrayOfRecurringBilling
     * @uses ArrayOfRecurringBilling::setRecurringBilling()
     * @param \eBizCharge\StructType\RecurringBilling[] $recurringBilling
     */
    public function __construct(array $recurringBilling = array())
    {
        $this
            ->setRecurringBilling($recurringBilling);
    }
    /**
     * Get RecurringBilling value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \eBizCharge\StructType\RecurringBilling[]|null
     */
    public function getRecurringBilling()
    {
        return isset($this->RecurringBilling) ? $this->RecurringBilling : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRecurringBilling method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRecurringBilling method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRecurringBillingForArrayConstraintsFromSetRecurringBilling(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRecurringBillingRecurringBillingItem) {
            // validation for constraint: itemType
            if (!$arrayOfRecurringBillingRecurringBillingItem instanceof \eBizCharge\StructType\RecurringBilling) {
                $invalidValues[] = is_object($arrayOfRecurringBillingRecurringBillingItem) ? get_class($arrayOfRecurringBillingRecurringBillingItem) : sprintf('%s(%s)', gettype($arrayOfRecurringBillingRecurringBillingItem), var_export($arrayOfRecurringBillingRecurringBillingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RecurringBilling property can only contain items of type \eBizCharge\StructType\RecurringBilling, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RecurringBilling value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\RecurringBilling[] $recurringBilling
     * @return \eBizCharge\ArrayType\ArrayOfRecurringBilling
     */
    public function setRecurringBilling(array $recurringBilling = array())
    {
        // validation for constraint: array
        if ('' !== ($recurringBillingArrayErrorMessage = self::validateRecurringBillingForArrayConstraintsFromSetRecurringBilling($recurringBilling))) {
            throw new \InvalidArgumentException($recurringBillingArrayErrorMessage, __LINE__);
        }
        if (is_null($recurringBilling) || (is_array($recurringBilling) && empty($recurringBilling))) {
            unset($this->RecurringBilling);
        } else {
            $this->RecurringBilling = $recurringBilling;
        }
        return $this;
    }
    /**
     * Add item to RecurringBilling value
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\RecurringBilling $item
     * @return \eBizCharge\ArrayType\ArrayOfRecurringBilling
     */
    public function addToRecurringBilling(\eBizCharge\StructType\RecurringBilling $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \eBizCharge\StructType\RecurringBilling) {
            throw new \InvalidArgumentException(sprintf('The RecurringBilling property can only contain items of type \eBizCharge\StructType\RecurringBilling, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RecurringBilling[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \eBizCharge\StructType\RecurringBilling|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \eBizCharge\StructType\RecurringBilling|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \eBizCharge\StructType\RecurringBilling|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \eBizCharge\StructType\RecurringBilling|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \eBizCharge\StructType\RecurringBilling|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RecurringBilling
     */
    public function getAttributeName()
    {
        return 'RecurringBilling';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\ArrayType\ArrayOfRecurringBilling
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
