<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddItem StructType
 * @subpackage Structs
 */
class AddItem extends AbstractStructBase
{
    /**
     * The securityToken
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\SecurityToken
     */
    public $securityToken;
    /**
     * The itemDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\ItemDetails
     */
    public $itemDetails;
    /**
     * Constructor method for AddItem
     * @uses AddItem::setSecurityToken()
     * @uses AddItem::setItemDetails()
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @param \eBizCharge\StructType\ItemDetails $itemDetails
     */
    public function __construct(\eBizCharge\StructType\SecurityToken $securityToken = null, \eBizCharge\StructType\ItemDetails $itemDetails = null)
    {
        $this
            ->setSecurityToken($securityToken)
            ->setItemDetails($itemDetails);
    }
    /**
     * Get securityToken value
     * @return \eBizCharge\StructType\SecurityToken|null
     */
    public function getSecurityToken()
    {
        return $this->securityToken;
    }
    /**
     * Set securityToken value
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @return \eBizCharge\StructType\AddItem
     */
    public function setSecurityToken(\eBizCharge\StructType\SecurityToken $securityToken = null)
    {
        $this->securityToken = $securityToken;
        return $this;
    }
    /**
     * Get itemDetails value
     * @return \eBizCharge\StructType\ItemDetails|null
     */
    public function getItemDetails()
    {
        return $this->itemDetails;
    }
    /**
     * Set itemDetails value
     * @param \eBizCharge\StructType\ItemDetails $itemDetails
     * @return \eBizCharge\StructType\AddItem
     */
    public function setItemDetails(\eBizCharge\StructType\ItemDetails $itemDetails = null)
    {
        $this->itemDetails = $itemDetails;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\StructType\AddItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
